import bpy

import ctypes

# from . import set_origin, text_editor, snapping_3d, node_ops, object_data_ops, viewport_display

import sys
import os
# Variables
toMoveToRecycle = []


def Main():
    # for obj in bpy.context.selected_objects:
    #     # item replacement
    #     if 'BfB-Block_Flag_Prefab' in obj.name:
    #         for objc in GetObjectChildren(obj):
    #             toMoveToRecycle.append(objc)
    #         Instantiate('Flag With Stick', obj.matrix_world.translation, obj.matrix_world.rotation)
    # bpy.ops.object.select_all(action='DESELECT')
    # for obj in toMoveToRecycle:
    #     obj.select_set(True)
    MakeAnimationParents()
    # ReplacementClones()


def MakeAnimationParents(parentSuffix=" Anim Parent"):
    ''' and put the parent in the active collection'''
    objsToReparent=[]
    for obj in bpy.context.selected_objects:
        objsToReparent.append(obj)
    for obj in objsToReparent:
        targetWorldMatrix = obj.matrix_world.copy()
        newParent = bpy.data.objects.new(
            name = obj.name + parentSuffix,
            object_data = None
        )
        # loc, rot, scale = obj.matrix_world.decompose()
        # replacement.location = loc
        # replacement.location = obj.matrix_world.to_translation()
        # replacement.rotation_quaternion = obj.matrix_world.to_quaternion()
        newParent.parent = obj.parent
        newParent.matrix_world = targetWorldMatrix
        obj.parent = newParent
        obj.matrix_world = targetWorldMatrix
        LinkObjectToCollection(newParent, GetActiveCollection())

def ReplacementClones():
    '''clone the active object to all the locations of the other selected objects and put the clones in the active collection'''
    activeObject = bpy.context.active_object
    objsToReplace=[]
    for obj in bpy.context.selected_objects:
        if(obj!=activeObject):
            objsToReplace.append(obj)
    for obj in objsToReplace:
        replacement = duplicateObject(activeObject)
        # loc, rot, scale = obj.matrix_world.decompose()
        # replacement.location = loc
        # replacement.location = obj.matrix_world.to_translation()
        # replacement.rotation_quaternion = obj.matrix_world.to_quaternion()
        replacement.matrix_world=obj.matrix_world
        LinkObjectToCollection(replacement, GetActiveCollection())
        


# Standard Methods

def duplicateObject(obj):
    # template_ob = obj
    # bpy.ops.object.duplicate({obj.name: template_ob,"selected_objects": [template_ob]}, linked=True)
    # ob = context.object  # newly duped object
    template_ob = obj
    # ob=object
    if template_ob:
        ob = template_ob.copy()
        # link to collection if need be
        # collection.objects.link(ob)
        data = ob.data
        if(data):
            ob.data = ob.data.copy()#copy data
        # # should check for action existing first
        # action = ob.animation_data.action
        # # make it a copy
        # ob.animation_data.action = action.copy()
        return ob
    else:
        return None

def FixParentInverseMatrix(ob):
    '''Fix that nasty unmanageable relationship. It's not a problem in unity.  pulled from blender stack exchange'''
    # Store a copy of the objects final transformation
    # so we can read from it later.
    ob_matrix_orig = ob.matrix_world.copy()
    # Reset parent inverse matrix.
    # (relationship created when parenting)
    ob.matrix_parent_inverse.identity()
    # Re-apply the difference between parent/child
    # (this writes directly into the loc/scale/rot) via a matrix.
    ob.matrix_basis = ob.parent.matrix_world.inverted() @ ob_matrix_orig

def GetObjectChildren(rootObject):
    ''' Gets all children of object.'''
    children = []
    for child in rootObject.children:
        children.append(child)
        for objc in GetObjectChildren(child):
            children.append(objc)
    return children

def InstantiateCollectionInstance(collection, location=(0,0,0), rotation=(0, 0, 0)):
    '''Instantiates a collection instance.'''
    # bpy.ops.object.collection_instance_add(
    #     collection=collectionName, location=location)
    instance_obj = bpy.data.objects.new(
        name="my_new__obj_instance_name", 
        object_data=None
    )
    instance_obj.instance_collection = collection
    instance_obj.instance_type = 'COLLECTION'
    return instance_obj


#region Collection Methods
def GetCollection(collectionName):
    '''Returns a collection by name.'''
    return bpy.data.collections[collectionName]
def GetActiveCollection():
    return bpy.context.view_layer.active_layer_collection.collection
def LinkObjectToCollection(object, collection):
    collection.objects.link(object)
#endregion
Main()
